//--------------------------------------------------------
//   AECintAP.C -- Displays " hh:mm:ss:ff" in client area
//		   AND the AECDLL.DLL Revision Number. 
//		   This code shows how to call the DLL to implement an
//			interrupt service rountine
//--------------------------------------------------------
    //NOTE: WHERE THERE IS A 'WO' IN THE COMMENTS BELOW, IT STANDS FOR
		// 'WINDOWS OVERHEAD'. THE 'WO' CODE HELPS TO DRAW THE
		// WINDOW, UPDATE THE WINDOW, ETC.

#include <windows.h>
#include <winioctl.h>		// in mstools\include dir
#include <stdio.h>
#include <stdlib.h>

#include "AECiNTTC.h"		//PROTOTYPES OF THE AECPC-TC.DLL FUNCTIONS
 

#define		true	1
#define		false	0
#define		NONE	0x0000
#define		IOR		0x0095
#define		MMR		0x0090
#define		SMART	0x0050
#define		VLTC	0x0050
#define		LTC		0x0098
#define		VITC	0x0093

typedef struct _AECBrdFnd
	{
		WORD	BrdAddr;
		int		BrdCkType;
		WORD	BrdModel;
		BOOL	BrdReads;
		PVOID	PhysAddr;
	} AECBrdFnd, *PAECBrdFnd;

//VARIABLE DEFINITIONS
AECBrdFnd	AecBoard[6];	// hold data for UP TO six time code boards
							// that are found (if they are installed).
int		BoardsFound;		// number of boards found in 'find all'
int		boardNum;			// number of boards found in registry
int		aecint;
int		IntIndex, IntCnt1, IntIndex2, IntCnt2, IntIndex3, IntCnt3;
int		IntCntBak1, IntCntBak2, IntCntBak3;
char	hhmmssff[30];		//data string to hold formated unpacked dataC
char	charStr[20], rev[2];//character string to hold data sent to screen

BYTE	rByte1, rByte2, rByte3;
BOOL	returnval, returnval1, returnval2, returnval3;
WORD	Brd1addr, Brd2addr, Brd3addr;
LPSTR	lpPassToAECDLLrev;	// typedef  char FAR*	LPSTR  
DWORD	RetDw, IORdw;
HANDLE	hWinRT2, hWinRT3, hWinRT4;


//FUNCTION PROTOTYPES
DWORD	TcISR1(HANDLE);	//my 1 isr
DWORD	TcISR2(HANDLE);	//my 2 isr	//NOT USED ONLY EXAMPLE
DWORD	TcISR3(HANDLE);	//my 3 isr
int		FindAllBoards(void);
void	RecordSmart(int, WORD);
void	ClearAllInts(int);
void	StartSmartRdr(int);




long WINAPI WndProc (HWND, UINT, UINT, LONG) ;
	    //window proceedure (WndProc) PROTOTYPE
HDC			hdc;				// WO
PAINTSTRUCT	ps;					// WO
RECT		rect;				// WO
MSG			msg;	//Global message structure that several
				    // functions use as a parameter

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int WINAPI WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
    {
	HANDLE hThreadTcISR1;               // Thread TcISR handle
	HANDLE hThreadTcISR2;              // Thread TcISR handle
	HANDLE hThreadTcISR3;              // Thread TcISR handle
	DWORD  threadIdTcISR1;              // ID of thread TcISR
    DWORD  threadIdTcISR2;             // ID of thread TcISR
    DWORD  threadIdTcISR3;             // ID of thread TcISR


    static char szAppName[] = "NT TEST AP" ;
    HWND	 hwnd ;
    WNDCLASS	 wndclass ;
    lpPassToAECDLLrev = (LPSTR) &rev;
	Brd1addr = 0x0000;	//init base addresses to NULL
	Brd2addr = 0x0000;	//init base addresses to NULL
	Brd3addr = 0x0000;	//init base addresses to NULL
	IntCnt1 = 0x00;		//init interrupt count
	IntCnt2 = 0x00;		//init interrupt count
	IntCnt3 = 0x00;		//init interrupt count
	IntCntBak1 = 0x00;	//init interrupt match count
	IntCntBak2 = 0x00;	//init interrupt match count
	IntCntBak3 = 0x00;	//init interrupt match count


	
	boardNum = AEC_PCTC_GET_NUMBER_OF_DEVICES ();	//
//--------------
// programaticly get all base addresses of boards installed & registered
//	and return the number of boards that were found.
// works with the first board(s) that was/were found (up to 3 of 6(maximum))
	BoardsFound = FindAllBoards();	
	if ( BoardsFound != 0 )			// 
		Brd1addr = AecBoard[0].BrdAddr;			
	if ( BoardsFound > 1 )
		Brd2addr = AecBoard[1].BrdAddr;
	if ( BoardsFound > 2 )
		Brd3addr = AecBoard[2].BrdAddr;
//--------------


    if (!hPrevInstance) // WO used to allow the creation of only one wndclass
          {
	  wndclass.style	 = CS_HREDRAW | CS_VREDRAW ;		// WO
	  wndclass.lpfnWndProc	 = WndProc ;				// WO
	  wndclass.cbClsExtra	 = 0 ;					// WO
	  wndclass.cbWndExtra	 = 0 ;					// WO
	  wndclass.hInstance	 = hInstance ;				// WO
	  wndclass.hIcon	 = LoadIcon (NULL, IDI_APPLICATION) ;	// WO
	  wndclass.hCursor	 = LoadCursor (NULL, IDC_ARROW) ;	// WO
	  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;	// WO
	  wndclass.lpszMenuName  = NULL ;				// WO
	  wndclass.lpszClassName = szAppName ;				// WO

	  RegisterClass (&wndclass) ;				// WO
	  }

    hwnd = CreateWindowEx (WS_EX_TOPMOST, // ext. window style(always on top)
		    szAppName,		 // address of registered class name
		    "AEC_NTTC ISR EXAMPLE",		     // window text
		    WS_THICKFRAME | WS_SYSMENU,	     // window style
		    10,				     // initial x position
		    30,				     // initial y position
		    0x120,			     // window width
		    0x50,			     // window height
            NULL,                // parent window handle
            NULL,                // window menu handle
            hInstance,           // program instance handle
		    NULL) ;				// creation parameters


////--------------  create a new thread to use as this board's ISR
	if ( Brd1addr != 0x0000 )
	{
		returnval1 = AEC_PCTC_INIT_BRD_INT (&hWinRT2, &IntIndex, &Brd1addr);
		if (returnval1)	// if not fail
		{
			hThreadTcISR1  = CreateThread(NULL, 0, 
                            (LPTHREAD_START_ROUTINE)TcISR1, hWinRT2,
                            CREATE_SUSPENDED, &threadIdTcISR1);
			SetThreadPriority(hThreadTcISR1, THREAD_PRIORITY_TIME_CRITICAL);
		}
	}

////--------------  create a new thread to use as this board's ISR
	if ( Brd2addr != 0x0000 )
	{
		returnval2 = AEC_PCTC_INIT_BRD_INT (&hWinRT3, &IntIndex2, &Brd2addr);
		if (returnval2)	// if not fail
		{
			hThreadTcISR2 = CreateThread(NULL, 0, 
                            (LPTHREAD_START_ROUTINE)TcISR2, hWinRT3,
                            CREATE_SUSPENDED, &threadIdTcISR2);
			SetThreadPriority(hThreadTcISR2, THREAD_PRIORITY_TIME_CRITICAL);
		}
	}

////--------------  create a new thread to use as this board's ISR
	if ( Brd3addr != 0x0000 )
	{
		returnval3 = AEC_PCTC_INIT_BRD_INT (&hWinRT4, &IntIndex3, &Brd3addr);
		if (returnval3)	// if not fail
		{
			hThreadTcISR3 = CreateThread(NULL, 0, 
                            (LPTHREAD_START_ROUTINE)TcISR3, hWinRT4,
                            CREATE_SUSPENDED, &threadIdTcISR3);
			SetThreadPriority(hThreadTcISR3, THREAD_PRIORITY_TIME_CRITICAL);
		}
	}
////-------------- 
// DO NOT START THE THREAD EXECUTION YET !!!
// PUT THE SMART BOARD INTO IDLE MODE AND CLEAR ALL THE BOARDS INTERRUPTS 
// BEFORE STARTING THREADS
////--------------

	ClearAllInts(BoardsFound);			// put smart boards in idle mode
										//  and clear all pending ints.

            // Start up the isr threads
	if (returnval1)	// if not fail
		RetDw = ResumeThread(hThreadTcISR1); // start this thread now
	if (returnval2)	// if not fail
		RetDw = ResumeThread(hThreadTcISR2); // start this thread now
	if (returnval3)	// if not fail
		RetDw = ResumeThread(hThreadTcISR3); // start this thread now
		//IORdw = SuspendThread(hThreadTcISR3); //pause the ISR (stop execution) 


	StartSmartRdr(BoardsFound);			// enable the smart readers

    ShowWindow (hwnd, nCmdShow) ;	// WO part of the window creation
    UpdateWindow (hwnd) ;			// WO part of the window creation


    //GetMessage (&msg, NULL, 0, 0);			// WO
    do
	{
		TranslateMessage (&msg) ;				// WO
		DispatchMessage (&msg) ;				// WO
		InvalidateRect ( hwnd, NULL, 0 );
	}
    while (GetMessage (&msg, NULL, 0, 0));		// WO
    TranslateMessage (&msg) ;					// WO
    DispatchMessage (&msg) ;					// WO
    return msg.wParam ; 						// WO
    }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		    //WINDOW PROC
long WINAPI WndProc (HWND hwnd, UINT message, UINT wParam,
                                                          LONG lParam)
     {

     switch (message)						// WO
          {
	  case WM_PAINT:
		  hdc = BeginPaint (hwnd, &ps) ;			// WO
		  GetClientRect (hwnd, &rect) ;			// WO


		  DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
		       hhmmssff,		//print the number of interrupts that each
		       wsprintf (hhmmssff,"%d   %d   %d", //of the ISRs have processed
			   IntCnt2, IntCnt1, IntCnt3),
		       &rect,
		       DT_SINGLELINE | DT_BOTTOM | DT_RIGHT);

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		if	(IntCntBak1 < IntCnt1)
		{
			IntCntBak1 = IntCnt1;
			aecint = AEC_PCTC_READ_ASC_TB (charStr, &Brd1addr);
			DrawText (hdc,			//PRINT IN THE WINDOW
		       charStr,
		       aecint,
		       &rect,
		       DT_SINGLELINE | DT_CENTER | DT_VCENTER);
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%X",
				Brd1addr),
				&rect,
				DT_SINGLELINE | DT_CENTER );
		}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		if	(IntCntBak2 < IntCnt2)
		{		
			IntCntBak2 = IntCnt2;
			aecint = AEC_PCTC_READ_ASC_TB (charStr, &Brd2addr);
			DrawText (hdc,			//PRINT IN THE WINDOW
			    charStr,
				aecint,
				&rect,
				DT_SINGLELINE | DT_VCENTER);
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%X",
				Brd2addr),
				&rect,
				DT_SINGLELINE );
		}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		if	(IntCntBak3 < IntCnt3)
		{
			IntCntBak3 = IntCnt3;
			aecint = AEC_PCTC_READ_ASC_TB (charStr, &Brd3addr);//(LPSTR, LPWORD)
			DrawText (hdc,			//PRINT IN THE WINDOW
			    charStr,
				aecint,
				&rect,
				DT_SINGLELINE | DT_RIGHT | DT_VCENTER);
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%X",
				Brd3addr),
				&rect,
				DT_SINGLELINE | DT_RIGHT );
		}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


		aecint = AEC_PCTC_GET_DLL_INFO (lpPassToAECDLLrev);
		//uses the AECDLL.DLL.  It passes the DLL revision 
		DrawText (hdc,			//PRINT THE DLL REV TO WINDOW
		       //rev,
		       //aecint,
			   hhmmssff,
			   wsprintf (hhmmssff,"DLL Rev. %c%c",
		 	   rev[0], rev[1]),
		       &rect,
		       DT_SINGLELINE  | DT_BOTTOM);
		
		EndPaint (hwnd, &ps) ;					//WO
	       return 0 ;								//WO

	  case WM_DESTROY:								// WO
	       PostQuitMessage (0) ;					// WO
	       return 0 ;								// WO
          }

     return DefWindowProc (hwnd, message, wParam, lParam) ;	// WO
     }



// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Call the 'Check_board' function for each of the possible addresses
//	that a time code board could be at and then store the board Type and
//	determine if the board has reading ability (some Smart boards are
//	generate only).  
// Returns the number of boards that where found.
//
//	PC-LTC/IOR BOARDS HAVE STANDARD ADDRESS JUMPER SETTINGS OF...
//	(port mapped)	200h, 220h, 280h, 2A0h, 300, 320h, 380h, & 3A0h
//	PC-LTC/MMR ... C0(00)h, C4(00)h, C8(00)h, CC(00)h, D0(00)h, D4(00)h
//	(memory mapped)		D8(00)h, & DC(00)h.
//	PC-LTC/(RDR, GEN, RG1) & ALL PC-VITC/XXX & ALL PC-VLTC/XXX HAVE
//		ADDRESS... CC00h, CD00h, CE00h, CF00h, DC00h, DD00h, DE00h, & DF00h
// The 'actual' address that the memory mapped boards are 'physically' 
//	mapped to is four bits higher than the jumper's lable. 
//	(ie: CC00 -> CC000h address
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int	  FindAllBoards(void)
{
	WORD	BrdAddr;
	int		CkType, FoundCnt;

//look for and IOR return value at the possible IOR addresses
	FoundCnt = 0x00;
	BrdAddr = 0x200;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);	// returns a 0(none), 
												// 1(IOR), 2(MMR), 3(Smart)		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x220;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x280;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x2A0;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x300;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x320;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x380;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x3A0;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}

//look for and MMR/Smart return value at the possible memory map addresses
	BrdAddr = 0xC000;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xC400;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xC800;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCC00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD000;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD400;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD800;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDC00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCD00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCE00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCF00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDD00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDE00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDF00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	return FoundCnt;
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	RecordSmart(int Cnt, WORD BrdAddr)
{
	WORD		Addr, OffsetE0, OffsetE1, OffsetE2, OffsetEF;
	BYTE		bId0, bId1, bId2, bType; // bytes from 3E0, 3E1, 3E2, 3EF.
	BYTE		bCom, bRet;
	BOOL		ok;
	
	Addr =  BrdAddr;
	OffsetE0 = 0x3E0;
	OffsetE1 = 0x3E1;
	OffsetE2 = 0x3E2;
	OffsetEF = 0x3EF;
	
	// read the smart board type id byte ( 0x50 VLTC, 0x93 VITC, 0x98 LTC)
	if (ok = AEC_PCTC_READ_1BYTE (&bType, &OffsetEF, &Addr))	
		AecBoard[Cnt].BrdModel = (WORD)bType;

	// read the board id bytes to see if this board reads tc.
	ok = AEC_PCTC_READ_1BYTE (&bId0, &OffsetE0, &Addr);
	ok = AEC_PCTC_READ_1BYTE (&bId1, &OffsetE1, &Addr);
	ok = AEC_PCTC_READ_1BYTE (&bId2, &OffsetE2, &Addr);
		
	if ((bId0 == 'R' ) || (bId1 == 'R' ) || (bId2 == 'R' ))
	{
		AecBoard[Cnt].BrdReads = TRUE;
		// now make sure that the board is in reader mode
		bCom = 0x16; // idle command  ltc/vitc/vltc
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
		if (bType ==0x50)
			bCom = 0x23; // dual reader mode command vltc board
		else bCom = 0x10; // reader mode command ltc/vitc boards
			
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);

	}
	else AecBoard[Cnt].BrdReads = FALSE;
	//no return for 'void'
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DWORD TcISR1(HANDLE hWinRT)		//board1
{

    for( ; TRUE; )				//THIS 'FOR' LOOP IS THE ISR FOR THE FIRST
								//BOARD.  THIS EXAMPLE ONLY UPDATES A
								//COUNTER THAT SHOWS THE NUMBER OF
								//INTERRUPTS THAT HAVE OCCURED.  THIS ISR
								//DOES NOT ATTEMT TO DISTINGUISH WHAT
								//CAUSES THE INTERRUPT.  THIS CODE DOES
								//ASSUME THAT THE BOARD IS CAPABLE OF
								//READING TIME CODE.  IF DIFFERENT CODE
								//PATHS NEED TO BE TAKEN, USE 'if' OR 
								//'switch/case' TO CONTROL THE ISR PROGRAM
								//FLOW BASED UPON THE RETURN VALUE 'rByte'
								//THE ISR WILL LOOP INDEFINITLY.  TO STOP
								//THE ISR, MAKE A CALL TO STOP THE ISR
								//THREAD!
    {  
		rByte1 = AEC_PCTC_ISR_1 (&Brd1addr);
			// wait for interrupt
		++IntCnt1;
    }
    return(NO_ERROR);       // can't get here
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DWORD TcISR2(HANDLE hWinRT)		//board2
{
    for( ; TRUE; )
    {  
		rByte2 = AEC_PCTC_ISR_2 (&Brd2addr);
			// wait for interrupt
		++IntCnt2;
    }
    return(NO_ERROR);       // can't get here
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DWORD TcISR3(HANDLE hWinRT)		//board3
{
    for( ; TRUE; )
    {  
		rByte3 = AEC_PCTC_ISR_3 (&Brd3addr);
			// wait for interrupt
		++IntCnt3;
    }
    return(NO_ERROR);       // can't get here
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	StartSmartRdr(int Cnt)
{
	BYTE	bCom, bRet;
	WORD	BrdAddr, OffsetEF;
	BYTE	IDb;
	int		i;
	BOOL	retV;


	OffsetEF = 0x3EF;
	for (i = 0; i < Cnt; i++)
	{
		if (AecBoard[i].BrdCkType == 3)
		{
			BrdAddr = AecBoard[i].BrdAddr;
			bRet = 0x05;	
			if (retV = AEC_PCTC_READ_1BYTE (&IDb, &OffsetEF, &BrdAddr))	
			{
				if (IDb == 0x50)
					bCom = 0x23; // dual reader mode command vltc board
				else bCom = 0x10; // reader mode command ltc/vitc boards
			
				retV = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &BrdAddr);
			}
		}
	}
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	ClearAllInts(int Cnt)
{
	WORD	BrdAddr;
	int		i, j;
	BOOL	retV;
	DWORD	BrdIdw;
	BYTE	bCom, bRet;

	for (i = 0; i < Cnt; i++)
	{
		BrdAddr = AecBoard[i].BrdAddr;
		if ((AecBoard[i].BrdCkType == 1) || (AecBoard[i].BrdCkType == 2))
		{
			returnval = AEC_PCTC_READ_TB (&BrdIdw, &BrdAddr);//
			returnval = AEC_PCTC_READ_TB (&BrdIdw, &BrdAddr);//
			returnval = AEC_PCTC_READ_TB (&BrdIdw, &BrdAddr);//
		}
		else //(AecBoard[i].BrdCkType = 3)
		{
			bRet = 0x05;	
			bCom = 0x16;	//put  all smart boards in idle mode				
			returnval = AEC_PCTC_SEND_COMMAND (&bCom, &bRet, &BrdAddr);
			bCom = 0x20;	//about 32ms delay	
			for (j = 0; j < 0x10; j++)	// clear out all of the pending ints if any
			{
				retV = AEC_PCTC_GET_INTCODE(&bCom, &bRet, &BrdAddr);//
			}
		}
	}
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	      // END OF CODE	END OF CODE		END OF CODE
