/*--------------------------------------------------------
   X_APP1.C -- Displays " hh:mm:ss:ff" in client area
		   AND the AECDLL.DLL Revision Number.
  --------------------------------------------------------*/
    //NOTE: WHERE THERE IS A 'WO' IN THE COMMENTS BELOW, IT STANDS FOR
		// 'WINDOWS OVERHEAD'. THE 'WO' CODE HELPS TO DRAW THE
		// WINDOW, UPDATE THE WINDOW, ETC.

#include <windows.h>
#include "aecdll.h"	      //PROTOTYPES OF THE AECPC-TC.DLL FUNCTIONS

//VARIABLE DEFINITIONS
int	tcbuffer[8], aecint;  /* global data string to hold unpacked time code*/
char	pctcdat[4];	      /*place to put time or user info from tcboard*/
char	hhmmssff[11];	      /*data string to hold formated unpacked dataC*/
char	num[20], rev[2];      /*character string to hold data sent to screen*/
BOOL	returnval;

BYTE	bCmdCode, ffreg, fereg, fdreg, testbyte;
UINT	wSelector;
DWORD	dwPCTCAddr, dwPCTCLength;
LPSTR	lpPCTCBoard, lpPassToAECDLLrev;	/* typedef  char FAR*	LPSTR  */

MSG	msg;			//Global message structure that several
				    // functions use as a parameter
				//PROTOTYPE OF FUNCTIONS....
void	unpacktc (void);	// put 4 bytes BCD into int[8] string
void	gettcdat (void);	// read gen output into byte[4] string
void	ans(void);		// allocate a new selector and initialize
void	dans(void);		// de-allocate a new selector and initialize
void	get_intr_code(void);	// read the byte of data at DPRAM 0x3FE
void	sendPCTCCom(BYTE);	// write the byte (code) into DPRAM 0x3FF
void	resetcom(void); 	// writes the reset code to DPRAM 0x3FF
void	initialGen(void);	// write the time the generator will start at
void	setGenInt(void);	// set the generator frame change interupt
void	testout(void);		// debug-test data


#define dwPCTCAddr    0x000CC000L /* Place 'board' address here */
#define dwPCTCLength  0x00000400L
		    /* Fixed 1kB (1024) segment size(limit) (DPRAM size)*/

UINT FAR PASCAL AllocSelector(UINT);		 /*prototype*/
UINT FAR PASCAL SetSelectorBase(UINT, DWORD);	 /*prototype*/
UINT FAR PASCAL SetSelectorLimit(UINT, DWORD);	 /*prototype*/
UINT FAR PASCAL FreeSelector(UINT);		 /*prototype*/



long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG) ;
	    /*window proceedure (WndProc) PROTOTYPE*/
HDC	     hdc;						// WO
PAINTSTRUCT  ps;						// WO
RECT	     rect;						// WO

/************************************************************************/

int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
    {
    static char szAppName[] = "TIME CODE" ;
    HWND	 hwnd ;
    WNDCLASS	 wndclass ;
    lpPassToAECDLLrev = (LPSTR) &rev;

    if (!hPrevInstance) // WO used to allow the creation of only one wndclass
          {
	  wndclass.style	 = CS_HREDRAW | CS_VREDRAW ;		// WO
	  wndclass.lpfnWndProc	 = WndProc ;				// WO
	  wndclass.cbClsExtra	 = 0 ;					// WO
	  wndclass.cbWndExtra	 = 0 ;					// WO
	  wndclass.hInstance	 = hInstance ;				// WO
	  wndclass.hIcon	 = LoadIcon (NULL, IDI_APPLICATION) ;	// WO
	  wndclass.hCursor	 = LoadCursor (NULL, IDC_ARROW) ;	// WO
	  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;	// WO
	  wndclass.lpszMenuName  = NULL ;				// WO
	  wndclass.lpszClassName = szAppName ;				// WO

	  RegisterClass (&wndclass) ;				// WO
	  }

    hwnd = CreateWindowEx (WS_EX_TOPMOST, // ext. window style(always on top)
		    szAppName,		 // address of registered class name
		    "AECPC-TC Demo1",		     // window text
		    WS_THICKFRAME | WS_SYSMENU,	     // window style
		    0,				     // initial x position
		    0,				     // initial y position
		    0x90,			     // window width
		    0x40,			     // window height
                    NULL,                    // parent window handle
                    NULL,                    // window menu handle
                    hInstance,               // program instance handle
		    NULL) ;		     // creation parameters

    ans();		   /* allocates new selector */
    resetcom();		   /* resets PCTC board */

    ShowWindow (hwnd, nCmdShow) ;	// WO part of the window creation
    UpdateWindow (hwnd) ;		// WO part of the window creation

    bCmdCode = 0x20;	   /*idle CODE*/
    sendPCTCCom(bCmdCode);
    initialGen();	    /* sets the time that gen will use when started */
    setGenInt();	    /* sets tc generator frame change interupt */
    bCmdCode = 0x41;	    /* load time code generator - tc only CODE */
    sendPCTCCom(bCmdCode);
    bCmdCode = 0x25;	    /*run LTC reader & TC Gen simultaniously CODE */
    sendPCTCCom(bCmdCode);
    bCmdCode = 0x48;	    /* start TC generator running CODE */
    sendPCTCCom(bCmdCode);

    GetMessage (&msg, NULL, 0, 0);				// WO
    do
	{
	TranslateMessage (&msg) ;				// WO
	DispatchMessage (&msg) ;				// WO
	do
	    {
	    fdreg = *(lpPCTCBoard + 0x3FD);
	    if ( fdreg != 0x00 )
		{
		get_intr_code();
		if ( fereg == 0x4C )  // repaint window when tc gen changes
		      {
			gettcdat();
			unpacktc ();
			InvalidateRect ( hwnd, NULL, 0 );
				// makes Windows update screen changes
			}
		}
	    }
	while (!(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)));	    //WO
	    // look for any messages (allows Windows access to polling loop)
	}
    while (GetMessage (&msg, NULL, 0, 0));			    //WO
	    // if message is not the WM_QUIT message continue in loop


    dans();	       /* De-Allocates New Selector */
    TranslateMessage (&msg) ;					// WO
    DispatchMessage (&msg) ;					// WO

    return msg.wParam ; 					// WO
    }

/********************************************************************/
		    //WINDOW PROC
long FAR PASCAL _export WndProc (HWND hwnd, UINT message, UINT wParam,
                                                          LONG lParam)
     {


     switch (message)						// WO
          {
	  case WM_PAINT:					// WO
	       hdc = BeginPaint (hwnd, &ps) ;			// WO

	       GetClientRect (hwnd, &rect) ;			// WO

	       DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
		       hhmmssff,
		       wsprintf (hhmmssff,"%d%d:%d%d:%d%d:%d%d",
			  tcbuffer[0], tcbuffer[1], tcbuffer[2], tcbuffer[3],
			  tcbuffer[4], tcbuffer[5], tcbuffer[6], tcbuffer[7]),
		       &rect,
		       DT_SINGLELINE | DT_CENTER );
			 /* formats time code data in center of window */
	       aecint = AEC_PCTC_GET_DLL_INFO (lpPassToAECDLLrev);
		// this line of code is the only code in this example that
		// uses the AECDLL.DLL.  It passes the DLL revision to the
		// application.
	       DrawText (hdc,			//PRINT THE DLL REV TO WINDOW
		       rev,
		       aecint,
		       &rect,
		       DT_SINGLELINE | DT_CENTER | DT_BOTTOM);

	       EndPaint (hwnd, &ps) ;			       //WO
	       return 0 ;				       //WO

	  case WM_DESTROY:					// WO
	       PostQuitMessage (0) ;				// WO
	       return 0 ;					// WO
          }

     return DefWindowProc (hwnd, message, wParam, lParam) ;	// WO
     }


/********************************************************************/

void get_intr_code()	// gets interupt ( or command echo )from 0x 3FE
    {
    do { fdreg = *(lpPCTCBoard + 0x3FD); }
	while (fdreg == 0x00 ); 	   /*wait for data 'ready'*/
    fereg = *(lpPCTCBoard + 0x3FE);	/*3FEreg gets the interupt code*/
    do { ffreg = *(lpPCTCBoard + 0x3FF);}
	while ( ffreg != 0xFF );	/*wait for 'FF' */
    *(lpPCTCBoard + 0x3FD) = 0x00;		 /* zero for next time */
    *(lpPCTCBoard + 0x3FF) = 0x00;	  /* enables the next interupt */
    }

/***********************************************************************/

void sendPCTCCom(BYTE comcode)	 // sends new command (comcode) to 0x3FF
    {
    do { ffreg = *(lpPCTCBoard + 0x3FF);}
	while ( ffreg != 0xFF );		     /*wait for 'FF' */
    ffreg = *(lpPCTCBoard + 0x3FF);		     /* do a 'dummy' read */
    *(lpPCTCBoard + 0x3FF) = comcode;	     /* sends mode command to PCTC*/
    do { get_intr_code(); }
	while (fereg != comcode);	     /*get command echo */
    }

/***********************************************************************/

void resetcom() 	   /* resets PCTC board */
     {
     do { ffreg = *(lpPCTCBoard + 0x3FF);}
	  while ( ffreg != 0xFF );		     /*wait for 'FF' */
     ffreg = *(lpPCTCBoard + 0x3FF);		     /* do a 'dummy' read */
     *(lpPCTCBoard + 0x3FF) = 0x02;	     /* sends reset code to PCTC*/
     }

/***********************************************************************/

void setGenInt(void)	  // set generator frame change interupt
    {
    *(lpPCTCBoard + 0x3F0) = 0x04; /* sets the tc gen interupt */
      /* this will cause a 0x4C instead of 0x13 (reader interupt code
	  which is default ) to appear in 0x3FE when gen frame changes */

    }

/***********************************************************************/

void initialGen()	  // load the time the generator will start at
    {
    *(lpPCTCBoard + 0x040) = 0x25;	     /* initial setting to be */
    *(lpPCTCBoard + 0x041) = 0x45;  /* 23:58:45:25 when generator starts*/
    *(lpPCTCBoard + 0x042) = 0x58;			/* packed BCD */
    *(lpPCTCBoard + 0x043) = 0x23;
    *(lpPCTCBoard + 0x048) = 0x00;  /* generator initialization code */
    *(lpPCTCBoard + 0x04C) = 0x00;		  /*  " "  */
    }

/*************************************************************************/

void	unpacktc ()	/* unpacks the time code byte data into 2ints*/
    {
					     //MASK 4 LOW OR SHIFT LEFT 4 BITS
	tcbuffer[0] = pctcdat[3] / 0x10;     /*PUTS BCDh into str.HHh*/
	tcbuffer[1] = pctcdat[3] & 0x0F;     /*Puts BCDl into str.HHl*/
	tcbuffer[2] = pctcdat[2] / 0x10;     /*Puts BCDl into str.MMh*/
	tcbuffer[3] = pctcdat[2] & 0x0F;     /*Puts BCDl into str.MMl*/
	tcbuffer[4] = pctcdat[1] / 0x10;     /*Puts BCDl into str.SSh*/
	tcbuffer[5] = pctcdat[1] & 0x0F;     /*Puts BCDl into str.SSl*/
	tcbuffer[6] = pctcdat[0] / 0x10;     /*PUTS BCDh into str.FFh*/
	tcbuffer[7] = pctcdat[0] & 0x0F;     /*Puts BCDl into str.FFl*/

    }

/*********************************************************************/

void	gettcdat (void) 	    /* copies TC gen output to small string */
    {
	pctcdat[0] = *(lpPCTCBoard + 0x050);	     /*TC Gen output frames*/
	pctcdat[1] = *(lpPCTCBoard + 0x051);			  /*seconds*/
	pctcdat[2] = *(lpPCTCBoard + 0x052);	       /*packed BCD minutes*/
	pctcdat[3] = *(lpPCTCBoard + 0x053);			    /*hours*/
    }
/*************************************************************************/

void ans()		// allocate new selector and initialize it
    {
    __asm   {
	    push ds
	    call AllocSelector
	    mov wSelector,ax
	    }
		    /* make new selector that has the same form as the Data
			Segment (ds) that can then be modified to meet the
			PCTC board requirements */

    if (wSelector)   // if no error occured when allocating new selector
	    {
	    SetSelectorBase(wSelector, dwPCTCAddr);	/*set new base addr*/
	    SetSelectorLimit(wSelector, dwPCTCLength);	/*new segment length*/
		    /* these values are PCTC board dependant  and are
			 defined near the top of the source code*/

	    }
//    lpPCTCBoard = GlobalLock(wSelector);
	      /* returns a far pointer to the selector and locks it
		      in linear memory	(points to PCTC board)
		      this one line is equivalent to the next two
		      lines of code (ie LockSegment, MAKELONG) */

    LockSegment (wSelector);	/* locks selector in linear memory */
    lpPCTCBoard = (LPSTR) MAKELONG(0, wSelector);
		     /* creates long pointer to the selector */
    }

/**************************************************************************/

void	dans(void)	   //De-Allocates the New Selector and frees it
    {
//   GlobalUnlock(wSelector);
	   /* this line in pair with GlobalLock in ans() function (IF USED)*/
     UnlockSegment (wSelector);	/* unlocks selector that was locked */
	    /* this line in pair with LockSegment in ans() funtion */
     FreeSelector(wSelector); /* frees up the 'new' selector before exit */
	    /* this line in pair with AllocSelector in ans() function */
    }

/*************************************************************************/
	      // END OF CODE	END OF CODE	END OF CODE
